

-- by Schnulla-817


Doors = {};

function Doors.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function Doors:load(xmlFile)

      local DOORLeftNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.DOORLeft#index"));
      if DOORLeftNode ~= nil then
        self.DOORLeft = {};
        self.DOORLeft.node = DOORLeftNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.DOORLeft#minTrans"));
        self.DOORLeft.minTrans = {};
        self.DOORLeft.minTrans[1] = Utils.getNoNil(x, 0);
        self.DOORLeft.minTrans[2] = Utils.getNoNil(y, 0);
        self.DOORLeft.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.DOORLeft#maxTrans"));
        self.DOORLeft.maxTrans = {};
        self.DOORLeft.maxTrans[1] = Utils.getNoNil(x, 0);
        self.DOORLeft.maxTrans[2] = Utils.getNoNil(y, 0);
        self.DOORLeft.maxTrans[3] = Utils.getNoNil(z, 0);

        self.DOORLeft.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.DOORLeft#transTime"), 2)*1000;
        self.DOORLeft.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.DOORLeft#touchTransLimit"), 10);
    end; 

      local DOORRightNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.DOORRight#index"));
      if DOORRightNode ~= nil then
        self.DOORRight = {};
        self.DOORRight.node = DOORRightNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.DOORRight#minTrans"));
        self.DOORRight.minTrans = {};
        self.DOORRight.minTrans[1] = Utils.getNoNil(x, 0);
        self.DOORRight.minTrans[2] = Utils.getNoNil(y, 0);
        self.DOORRight.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.DOORRight#maxTrans"));
        self.DOORRight.maxTrans = {};
        self.DOORRight.maxTrans[1] = Utils.getNoNil(x, 0);
        self.DOORRight.maxTrans[2] = Utils.getNoNil(y, 0);
        self.DOORRight.maxTrans[3] = Utils.getNoNil(z, 0);

        self.DOORRight.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.DOORRight#transTime"), 2)*1000;
        self.DOORRight.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.DOORRight#touchTransLimit"), 10);
    end; 

end;

function Doors:keyEvent(unicode, sym, modifier, isDown)
end;

function Doors:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Doors:update(dt)

	if self:getIsActiveForInput() and self.isEntered then
	if InputBinding.hasEvent(InputBinding.DOOR_Left) then
		self.DOORLeftMax = not self.DOORLeftMax;
	end;

	if InputBinding.hasEvent(InputBinding.DOOR_Right) then
		self.DOORRightMax = not self.DOORRightMax;
	end;

--    if self.isEntered then
		local doTranslate = self.DOORLeftMax or not self.DOORLeftMax
		if self.DOORLeft ~= nil and doTranslate then 
			local x, y, z = getTranslation(self.DOORLeft.node); 
			local trans = {x,y,z}; 
			local newTrans = Utils.getMovedLimitedValues(trans, self.DOORLeft.maxTrans, self.DOORLeft.minTrans, 3, self.DOORLeft.transTime, dt, not self.DOORLeftMax); 
			setTranslation(self.DOORLeft.node, unpack(newTrans)); 
		end; 
	
		local doTranslate = self.DOORRightMax or not self.DOORRightMax
		if self.DOORRight ~= nil and doTranslate then 
			local x, y, z = getTranslation(self.DOORRight.node); 
			local trans = {x,y,z}; 
			local newTrans = Utils.getMovedLimitedValues(trans, self.DOORRight.maxTrans, self.DOORRight.minTrans, 3, self.DOORRight.transTime, dt, not self.DOORRightMax); 
			setTranslation(self.DOORRight.node, unpack(newTrans)); 
		end; 
	end;

end;

function Doors:draw()
end;

function Doors:onEnter()
end;

function Doors:onLeave()
end;

function Doors:delete()
end;